// Adressenverwaltung, Datenhaltung in Array, ohne Speichern in Datei

#include <iostream>
using namespace std;

const int maxadr = 100;

struct Adresse
{
  char vorname[21];
  char name[21];
  int alter;
};

char frageBenutzer();
void zeigeAdressen(const Adresse adrdb[], int aktpos);
void neueAdresse(Adresse &neue);

void main()
{
	Adresse adrdb[maxadr];
	int aktpos = -1;
	char antwort;

	while ((antwort = frageBenutzer()) != 'x')
	{
		switch (antwort)
		{
			case 'a':	if (aktpos >= 0)
							zeigeAdressen(adrdb, aktpos);
						break;
			case 'n':	if (aktpos < maxadr-1) 
							neueAdresse(adrdb[++aktpos]);
				        break;
			case 'd':	if (aktpos >= 0)
							aktpos--;
				        break;
			case 'x':	break;
		}
	}
}

char frageBenutzer()
{
	char antwort;
	
	cout << "Adressenverwaltung:\n";
	cout << "------------------\n";
	cout << "Was moechten Sie tun?\n";
	cout << "  a = Adressen anzeigen\n";
	cout << "  n = neue Adresse aufnehmen\n";
	cout << "  d = letzte Adresse loeschen\n";
	cout << "  x = Programm beenden\n";
	cout << "Ihre Wahl: ";
	cin >> antwort;
	cout << "\n\n";
	return antwort;
}

void zeigeAdressen(const Adresse adrdb[], int aktpos)
{
	cout << "Anzahl der Adressen: " << aktpos+1 << endl << endl;
	for (int i=0; i<=aktpos; i++)
	{
		cout << "Vorname: " << adrdb[i].vorname << endl;
		cout << "Name:    " << adrdb[i].name << endl;
		cout << "Alter:   " << adrdb[i].alter << endl << endl;
	}
}


/*
first ("fill & reset") fllt die Strings rechts mit Leerzeichen auf und setzt cin zurck,
falls der Benutzer die maximale Eingabelnge berschritten hat (cin.rdstate = 2):
  - Das failbit wird mit cin.clear auf 0 gesetzt.
  - Die brig gebliebenen Zeichen bis zum Newline (einschl.) werden mit cin.ignore entfernt.
*/
void first(char instring[], int laenge)
{
	for (int i = strlen(instring); i < laenge; i++)
		strcat(instring, " ");
	if (cin.rdstate() != 0)
	{
		cin.clear(0);
		// INT_MAX (= 2147483647) Zeichen werden maximal entsorgt.
		cin.ignore(INT_MAX, '\n');
	}
}

void neueAdresse(Adresse &neue)
{
	// ignore ist erforderlich, weil der >>-Operator das Newline-Zeichen nicht entsorgt hat.
	cin.ignore(1);

	cout << "Vorname: ";
	cin.getline (neue.vorname,20);
	first(neue.vorname, 20);

	cout << "Name:    ";
	cin.getline (neue.name, 20);
	first(neue.name, 20);

	cout << "Alter:   ";
	char temp[5], *ep;
	cin.getline (temp, 3);
	first(temp, 4);
	neue.alter = strtol(temp, &ep, 10);
	if ((int) *ep != 32)
		neue.alter = -1;
	cout << "\n\n";
}

