// Primzahlenbestimmung mit dem Sieb des Eratosthenes, dynamisches Feld

#include <iostream>
using namespace std;

const int maxkand = 1000000;

int ask()
{
	int lg;
	do
	{
		cout << "Suchen bis (erlaubt: 3 bis " << maxkand << ", Beenden mit 0): "; 
		cin >> lg;
		if (lg == 0)
		{
			exit(0);
		}
		else if (lg < 3 || lg > maxkand)
		{
			cout << "Illegaler Grenzuebertritt!" << endl;
		}
	} while (lg < 3  || lg > maxkand);
	return lg;	
}	

void main()
{
	bool *prim;
	int grenze, i, j;
	while (true)
	{
		grenze = ask();
		prim = new bool [grenze+1];
		if (prim == NULL)
		{
			cout << "\aSpeichermangel!" << endl;
			continue;
		}
		for (i = 1; i <= grenze; i++) prim[i] = true;
		for (i = 2; i <= grenze/2; i++)
		{
			if (!prim[i]) continue;
			for (j = 2; j*i <= grenze; j++) prim[j*i] = false;
		}

		cout << "Primzahlen von 1 bis " << grenze << ":" << endl;
		cout << " 1, 2, 3";
		for (i = 5; i <= grenze; i++)
			if (prim[i]) cout << ", " << i;
		cout << endl << endl;
	}
}
