//Methoden der Klasse Bruch implementieren

#include "Bruch.h"

//Klassenvariablen definieren und initialisieren:
int Bruch::nbrobj = 0;
bool Bruch::zginit = false;


Bruch::Bruch()
{
	nbrobj++;
	if (!zginit)
	{
		srand(unsigned(time(NULL)));
		nenner = rand();
		zginit = true;
	}
	nenner = rand() % 9 + 1;
	zaehler = rand() % nenner + 1;
}


Bruch::Bruch(int z, int n)
{
	nbrobj++;
	zaehler = z;
	if (n)
	{
		nenner = n;
		def = 1;
	}
	else
	{
		def = 0;
	}
}

Bruch::~Bruch()
{
	nbrobj--;
}


void Bruch::zeige() const
{
	cout << "\n  " << zaehler << "\n-----\n"
	     << "  " << nenner << endl;
}

void Bruch::sz(int z)
{
	zaehler = z;
}

void Bruch::sn(int n)
{
	if (n != 0)
		nenner = n;
}

void Bruch::erweitere(int faktor)
{
	zaehler *= faktor;
	nenner  *= faktor;
}

void Bruch::addiere(const Bruch& b1, const Bruch& b2)
{
	zaehler = b1.hz() * b2.hn() + b1.hn() * b2.hz();
	nenner  = b1.hn() * b2.hn();
	kuerze();
}

void Bruch::multipliziere(const Bruch& b1, const Bruch& b2)
{
	zaehler = b1.hz() * b2.hz();
	nenner  = b1.hn() * b2.hn();
}

void Bruch::kuerze()
{
	int ggt, min, max, i;

	ggt = 1;
	if (zaehler >= nenner)
		{min = zaehler; max = nenner;}
	else
		{min = nenner; max = zaehler;}
	for (i = 1; i <= min; i++)
	{
		if (min % i == 0)
			if (max % i == 0)
			{
				ggt = i;
			}
	}
	zaehler /= ggt;
	nenner  /= ggt;
}

Bruch Bruch::operator+(const Bruch& b2) const
{
	Bruch temp(zaehler * b2.hn() + nenner * b2.hz(), nenner * b2.hn());
	temp.kuerze();
	return temp;
}

Bruch Bruch::kf()
{
	Bruch temp = *this;
	temp.kuerze();
	return temp;
}
