// ModeView.cpp : Implementierung der Klasse CModeView
//

#include "stdafx.h"
#include "Mode.h"

#include "ModeDoc.h"
#include "ModeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CModeView

IMPLEMENT_DYNCREATE(CModeView, CView)

BEGIN_MESSAGE_MAP(CModeView, CView)
	//{{AFX_MSG_MAP(CModeView)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_BUTTON_BLACK, OnButtonBlack)
	ON_COMMAND(ID_BUTTON_BLUE, OnButtonBlue)
	ON_COMMAND(ID_BUTTON_GREEN, OnButtonGreen)
	ON_COMMAND(ID_BUTTON_RED, OnButtonRed)
	ON_COMMAND(ID_BUTTON_WHITE, OnButtonWhite)
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModeView Konstruktion/Destruktion

CModeView::CModeView()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen,
	m_clrCurrent = RGB(255, 0, 0);
}

CModeView::~CModeView()
{
}

BOOL CModeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// ZU ERLEDIGEN: ndern Sie hier die Fensterklasse oder das Erscheinungsbild, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CModeView Zeichnen

void CModeView::OnDraw(CDC* pDC)
{
	CModeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// ZU ERLEDIGEN: Hier Code zum Zeichnen der ursprnglichen Daten hinzufgen

	pDC->SetMapMode(MM_LOMETRIC);

	COLORREF color;
	int x1, x2, y1, y2;
	CRect rect;
	for (int i = 0; i < 16; i++)

		for (int j = 0; j < 16; j++)
		{
			color = pDoc->GetCellColor(i, j);
			CBrush brush(color);
			x1 = (j * 100) + 100;
			y1 = (i * -100) - 100;
			x2 = x1 + 100;
			y2 = y1 - 100;

			rect.SetRect(x1, y1, x2, y2);
			pDC->FillRect(rect, &brush);

		}

}

/////////////////////////////////////////////////////////////////////////////
// CModeView Drucken

BOOL CModeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CModeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CModeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}

/////////////////////////////////////////////////////////////////////////////
// CModeView Diagnose

#ifdef _DEBUG
void CModeView::AssertValid() const
{
	CView::AssertValid();
}

void CModeView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CModeDoc* CModeView::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CModeDoc)));
	return (CModeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CModeView Nachrichten-Handler

void CModeView::OnLButtonDown(UINT nFlags, CPoint point) 
{

	// TODO: Code fr die Behandlungsroutine fr Nachrichten
	// hier einfgen und/oder Standard aufrufen
	CView::OnLButtonDown(nFlags, point);

	int i, j;
	CModeDoc * pDoc = GetDocument();

	CClientDC dc(this);
	dc.SetMapMode(MM_LOMETRIC);
	CPoint lpos = point;
	dc.DPtoLP(&lpos);
	
	if(lpos.x >= 100  &&  lpos.x <= 1700  &&
	   lpos.y <= -100  &&  lpos.y >= -1700)
	{
		i = (-lpos.y - 100) / 100;
		j = (lpos.x - 100) / 100;
		pDoc->SetCellColor(i, j, m_clrCurrent);
	}

}

void CModeView::OnButtonBlack() 
{
	m_clrCurrent = RGB(0,0,0);
}

void CModeView::OnButtonBlue() 
{
	m_clrCurrent = RGB(0,0,255);
}

void CModeView::OnButtonGreen() 
{
	m_clrCurrent = RGB(0,255,0);
}

void CModeView::OnButtonRed() 
{
	m_clrCurrent = RGB(255,0,0);
}

void CModeView::OnButtonWhite() 
{
	m_clrCurrent = RGB(255,255,255);
}
